var get_board_type_xhr = new XMLHttpRequest();
var board_types = {reserved: 0, hdi: 1, di: 2, ai: 3, cti: 4,
            rtd: 5, ao: 7, ro: 8, hdo: 9, io1: 10, em_h: 16, em_l: 17, io3:18, hdi_5: 11, 
            deleted: 255}
var selected_accordion = 0;

function form_tag_tr(param_name, eds_index, eds_subindex)
{
    var tr = $('<tr class="can_hide">');
    tr.append($('<td>').text(param_name).addClass("name"));
    var div = $('<div>').addClass("io").addClass("tag").attr({"index": `${eds_index.toString(16).toUpperCase()}:${eds_subindex}`});
    tr.append($('<td>').append(div));
    return tr;
}

function form_tag_tr2(param_name, eds_index, eds_subindex, param_name2, eds_index2, eds_subindex2)
{
    var tr = $('<tr class="can_hide">');
    tr.append($('<td>').text(param_name).addClass("name"));
    var div = $('<div>').addClass("io").addClass("tag").attr({"index": `${eds_index.toString(16).toUpperCase()}:${eds_subindex}`});
    tr.append($('<td>').append(div));
    tr.append($('<td>').addClass('empty_space'));
    tr.append($('<td>').text(param_name2).addClass("name"));
    var div2 = $('<div>').addClass("io").addClass("tag").attr({"index": `${eds_index2.toString(16).toUpperCase()}:${eds_subindex2}`});
    tr.append($('<td>').append(div2));
    return tr;
}

function form_name_tr(param_name)
{
    var tr = $('<tr class="can_hide">');
    tr.append($('<td>').text(param_name).addClass("name"));
    tr.append($('<td>'));
    return tr;
}

function form_tag_divide_tr(param_name, eds_index_num, eds_subindex_num, eds_index_den, eds_subindex_den)
{
    var tr = $('<tr class="can_hide">');
    tr.append($('<td>').text(param_name).addClass("name"));
    var table = $('<table>');

    var div1 = $('<div>').addClass("io").addClass("tag").attr({"index": `${eds_index_num.toString(16).toUpperCase()}:${eds_subindex_num}`});
    var div2 = $('<div>').addClass("io").addClass("tag").attr({"index": `${eds_index_den.toString(16).toUpperCase()}:${eds_subindex_den}`});
    table.append($('<tr>').append(($('<td style="border-bottom-color: black">').append(div1))))
    table.append($('<tr>').append(($('<td>').append(div2))))
    tr.append($('<td>').append(table));
    return tr;
}

function form_multy_tag_tr(param_name, eds_index, count, start_index=1)
{
    tr = $('<tr class="can_hide">');
    if (param_name == "Value")
    {
        tr.addClass("main_value");
    }
    tr.append($('<td>').text(param_name).addClass("name"));
    for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
    {
        var div = $('<div>').addClass("io").addClass("tag").attr({"index": `${eds_index.toString(16).toUpperCase()}:${eds_subindex}`});
        
        tr.append($('<td>').append(div));
    }
    return tr;
}

function form_multy_header(param_name, count)
{
    tr = $('<tr class="table_header">');
    tr.append($('<td>').text(param_name).addClass("name"));
    for (var eds_subindex = 1; eds_subindex < count+1; eds_subindex++)
    {
        var div = $('<div>').text(eds_subindex);
        tr.append($('<td>').append(div));
    }
    return tr;
}

function create_block(element, data)
{
    
    var table = $('<table>');
    tr = $('<tr>')

    $.each(data.blocks, function(block_index, block_item)
    {
        table_inner = $('<table>');
        $.each(block_item.params, function(param_index, param_item)
        {
            if (param_item.index != null && param_item.sub != null)
            {
                table_inner.append(form_tag_tr(param_item.name, param_item.index, param_item.sub));
            }
            else
            {
                table_inner.append(form_name_tr(param_item.name));
            }
        })
        td = $('<td>').append(table_inner)
        td_empty_space = $('<td>').addClass("empty_space")
        tr.append(td)
        tr.append(td_empty_space)
    })
    
    table.append(tr)		
    element.append(table);
}

$(document).ready(function() 
{
    var query = 'get_od_data.form?';

        var board_index = "0x3F01"
        var board_div = $('<div>').addClass("board").attr({"id": `board_0`})

        var board_name_table = $('<table>').append(form_tag_tr(`Board 0: `, 0x3F00, 1))
        board_name_table.addClass('board_name')
        //var board_head = $('<div>').append(board_name_table).addClass("accordion-header").attr({"status_index": `${board_index}:1`})
        var board_body = $('<div>').addClass("accordion-body");
        var table = $('<table>');


        board_body.append(table);

        
        var board_status = $('<div>').addClass('tag').addClass('board_status').attr({"index": `${board_index}:1`}).hide()
        board_body.append(board_status);
        //board_div.append(board_head);
        board_div.append(board_body);
        $("#board_head").append(board_div);

        query += `0x1027_1`; //board type

    var start_number = 1;
    var end_number = 9;

    for (var board_number = start_number; board_number <= end_number; board_number++)
    {
        if(board_number<end_number)
        {
        var board_index = (0x4001 + (board_number - 1)*0x100).toString(16).toUpperCase()
        var board_div = $('<div>').addClass("board").attr({"id": `board_${board_number}`})
        //var board_head = $('<div>').addClass("accordion-header").text(`Board: ${board_number}`);
        var board_name_table = $('<table>').append(form_tag_tr(`Board ${board_number}: `, 0x4000 + (board_number - 1)*0x100, 1))
        board_name_table.addClass('board_name')
        var board_head = $('<div>').append(board_name_table).addClass("accordion-header").attr({"status_index": `${board_index}:1`})
        var board_body = $('<div>').addClass("accordion-body");
        var table = $('<table>');
        //table.append(form_tag_tr("Name: ", 0x4000 + (board_number - 1)*0x100, 1));
        //table.append(form_tag_tr("Type: ", 0x1027, board_number + 1));
        //table.append(form_tag_tr("Board status: ", 0x4001 + (board_number - 1)*0x100, 1));

        board_body.append(table);
        //board_body.append(`<div index="${0x4001 + (board_number - 1)*0x100}:1" class="tag"></div>`)
        
        var board_status = $('<div>').addClass('tag').addClass('board_status').attr({"index": `${board_index}:1`}).hide()
        board_body.append(board_status);
        board_div.append(board_head);
        board_div.append(board_body);
        $("#io_settings").append(board_div);
        }
        if (board_number >= start_number)
        {
            query += "&";
        }
        //var board_type = (0x4000 + board_number*0x100).toString(16).toUpperCase();
        //query += `0x${board_type}_${2}`; //board type
        query += `0x1027_${(board_number)}`; //board type
    }
    
    get_board_type_xhr.open('GET', query, true);
    get_board_type_xhr.send();

    $("#boyan").accordion({ heightStyle: 'content', header: '.accordion-header', active: 0});
    $("#boyan").accordion( "option", "collapsible", true );
});

function show_boards_by_type(types)
{
for (var board_number = 0; board_number < 9; board_number++)
{
//console.log("board_number "+board_number);
//console.log("types[board_number] "+types[board_number])
if (types[board_number] != null)
{
    var type = types[board_number].replace(/\u0000/g, '');
    var type1 = types[1].replace(/\u0000/g, '');

    if (type == board_types.deleted)
    {
	$(`#board_${board_number}`).hide();
    }
    else
    {
	var table = $('<table>').addClass('data');
	if (type == board_types.di)
	{                  
	    var count = 10;
	    if (board_number == 0)
		count = 5;
	    
	    table.append(form_multy_header("DI:", count));
	    table.append(form_multy_tag_tr("Value", 0x3F11 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Invert polarity", 0x3F12 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Filter time, ms", 0x3F13 + board_number*0x100, count));

	    $(`#board_${board_number}`).children('.accordion-body').append(table);
	}
	if (type == board_types.hdi)
	{
		var count = 10;
		if (board_number == 0)
			count = 5;
		if (type1 == board_types.io1) {
		}
		else {
			table.append(form_multy_header("HDI:", count));
			table.append(form_multy_tag_tr("Value", 0x3F11 + board_number * 0x100, count));
			table.append(form_multy_tag_tr("Invert polarity", 0x3F12 + board_number * 0x100, count));
			table.append(form_multy_tag_tr("Filter time, ms", 0x3F13 + board_number * 0x100, count));

			$(`#board_${board_number}`).children('.accordion-body').append(table);
		}
	}
	else if (type == board_types.hdo)
	{
	    var count = 10;
	    if (board_number == 0)
		count = 5;
	    table.append(form_multy_header("HDO:", count));
	    table.append(form_multy_tag_tr("Value", 0x3F21 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Invert polarity", 0x3F22 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Error mode", 0x3F23 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Error value", 0x3F24 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Filter mask", 0x3F25 + board_number*0x100, count));

	    $(`#board_${board_number}`).children('.accordion-body').append(table);
	}
	else if ((type == board_types.ai) || (type == board_types.cti))
	{
	    var count = 8;
	    table.append(form_multy_header("Channel:", count));
	    table.append(form_multy_tag_tr("Value", 0x3F31 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Scaling", 0x3F32 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Offset", 0x3F33 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Filter time, ms", 0x3F34 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Deadband Reference", 0x3F3C + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Deadband, %", 0x3F35 + board_number*0x100, count));
	  
	    //table.append(form_multy_tag_tr("Float processed", 0x3F3B + board_number*0x100, count));

	    $(`#board_${board_number}`).children('.accordion-body').append(table);
	}
	else if (type == board_types.io3)
	{	var main_div = $('<div>').addClass('tab-class');
		li=$('<li>').append($('<a>').prop('href',`#rtd-tab-${board_number}`).append("RTD"))
		ul=$('<ul>')
		ul.append(li).append($('<li>').append($('<a>').prop('href',`#cti-tab-${board_number}`).append("CTI")));
		ul.append($('<li>').append($('<a>').prop('href',`#ai-tab-${board_number}`).append("AI")));
		main_div.append(ul)

		tab_table = $('<table>')
		tbody_cti = $('<tbody>').prop('id',`cti-tab-${board_number}`)
		tbody_rtd = $('<tbody>').prop('id',`rtd-tab-${board_number}`)
		tbody_ai = $('<tbody>').prop('id',`ai-tab-${board_number}`)



	    var count = 2;
	
	    tbody_cti.append(form_multy_header("Channel:", count));
	    tbody_cti.append(form_multy_tag_tr("Value", 0x3F31 + board_number*0x100, count));
	    tbody_cti.append(form_multy_tag_tr("Scaling", 0x3F32 + board_number*0x100, count));
	    tbody_cti.append(form_multy_tag_tr("Offset", 0x3F33 + board_number*0x100, count));
	    tbody_cti.append(form_multy_tag_tr("Filter time, ms", 0x3F34 + board_number*0x100, count));
	    tbody_cti.append(form_multy_tag_tr("Deadband Reference", 0x3F3C + board_number*0x100, count));
	    tbody_cti.append(form_multy_tag_tr("Deadband, %", 0x3F35 + board_number*0x100, count));

	    //table.append(form_multy_tag_tr("Float processed", 0x3F3B + board_number*0x100, count));

	    tab_table.append(tbody_cti);

	    var count = 2;
	    var start=7;
	    
	    tbody_rtd.append(form_multy_header("Channel:", count));
	    tbody_rtd.append(form_multy_tag_tr("Value", 0x3F31 + board_number*0x100, count, start));
	    tbody_rtd.append(form_multy_tag_tr("Settings", 0x3F39 + board_number*0x100, count, start));
	    tbody_rtd.append(form_multy_tag_tr("Scaling", 0x3F32 + board_number*0x100, count, start));
	    tbody_rtd.append(form_multy_tag_tr("Offset", 0x3F33 + board_number*0x100, count, start));
	    tbody_rtd.append(form_multy_tag_tr("Filter time, ms", 0x3F34 + board_number*0x100, count, start));
	    tbody_rtd.append(form_multy_tag_tr("Deadband Reference", 0x3F3C + board_number*0x100, count, start));
	    tbody_rtd.append(form_multy_tag_tr("Deadband, %", 0x3F35 + board_number*0x100, count, start));

	    //tbody_rtd.append(form_multy_tag_tr("Float processed", 0x3F3B + board_number*0x100, count));
	    tab_table.append(tbody_rtd)

    
	    var count = 2;
	    var start = 5;	
	    tbody_ai.append(form_multy_header("Channel:", count));
	    tbody_ai.append(form_multy_tag_tr("Value", 0x3F31 + board_number*0x100, count, start));
	    tbody_ai.append(form_multy_tag_tr("Scaling", 0x3F32 + board_number*0x100, count, start));
	    tbody_ai.append(form_multy_tag_tr("Offset", 0x3F33 + board_number*0x100, count, start));
	    tbody_ai.append(form_multy_tag_tr("Filter time, ms", 0x3F34 + board_number*0x100, count, start));
	    tbody_ai.append(form_multy_tag_tr("Deadband Reference", 0x3F3C + board_number*0x100, count, start));
	    tbody_ai.append(form_multy_tag_tr("Deadband, %", 0x3F35 + board_number*0x100, count, start));

	    tab_table.append(tbody_ai)
	    main_div.append(tab_table)
	    //table.append(form_multy_tag_tr("Float processed", 0x3F3B + board_number*0x100, count));

	    $(`#board_${board_number}`).children('.accordion-body').append(main_div);



	    
	}
	 else if (type == board_types.rtd)
	{
	    var count = 4;
	    table.append(form_multy_header("Channel:", count));
	    table.append(form_multy_tag_tr("Value", 0x3F31 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Settings", 0x3F39 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Scaling", 0x3F32 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Offset", 0x3F33 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Filter time, ms", 0x3F34 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Deadband Reference", 0x3F3C + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Deadband, %", 0x3F35 + board_number*0x100, count));

	    //table.append(form_multy_tag_tr("Float processed", 0x3F3B + board_number*0x100, count));

	    $(`#board_${board_number}`).children('.accordion-body').append(table);
	}
	else if (type == board_types.ao)
	{
	    var count = 2;
	    table.append(form_multy_header("Channel:", count));
	    table.append(form_multy_tag_tr("Value", 0x3F41 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Scaling", 0x3F43 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Offset", 0x3F42 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Error mode", 0x3F44 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Error value", 0x3F45 + board_number*0x100, count));

	    $(`#board_${board_number}`).children('.accordion-body').append(table);
	}
	else if (type == board_types.ro)
	{
	    var count = 4;
	    table.append(form_multy_header("RO:", count));
	    table.append(form_multy_tag_tr("Value", 0x3F21 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Invert polarity", 0x3F22 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Error mode", 0x3F23 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Error value", 0x3F24 + board_number*0x100, count));
	    table.append(form_multy_tag_tr("Filter mask", 0x3F25 + board_number*0x100, count));

	    $(`#board_${board_number}`).children('.accordion-body').append(table);
	}
	else if (type == board_types.io1) {
		var main_div = $('<div>').addClass('tab-class');
		li=$('<li>').append($('<a>').prop('href',`#di-tab-${board_number}`).append("DI"))
		ul=$('<ul>')
		ul.append(li).append($('<li>').append($('<a>').prop('href',`#do-tab-${board_number}`).append("DO")));
		ul.append($('<li>').append($('<a>').prop('href',`#alarm-tab-${board_number}`).append("Alarm")));
		main_div.append(ul)

		tab_table = $('<table>')
		tbody_di = $('<tbody>').prop('id',`di-tab-${board_number}`)
		tbody_do = $('<tbody>').prop('id',`do-tab-${board_number}`)
		tbody_alarm = $('<tbody>').prop('id',`alarm-tab-${board_number}`)


		var count = 5;
		tbody_di.append(form_multy_header("HDI:", count));
		tbody_di.append(form_multy_tag_tr("Value", 0x3F11 + board_number * 0x100, count));
		tbody_di.append(form_multy_tag_tr("Invert polarity", 0x3F12 + board_number * 0x100, count));
		tbody_di.append(form_multy_tag_tr("Filter time, ms", 0x3F13 + board_number * 0x100, count));
		
		count = 2;
		tbody_do.append(form_multy_header("HDO:", count));
		tbody_do.append(form_multy_tag_tr("Value", 0x3F21 + board_number * 0x100, count));
		tbody_do.append(form_multy_tag_tr("Invert polarity", 0x3F22 + board_number * 0x100, count));
		tbody_do.append(form_multy_tag_tr("Error mode", 0x3F23 + board_number * 0x100, count));
		tbody_do.append(form_multy_tag_tr("Error value", 0x3F24 + board_number * 0x100, count));
		tbody_do.append(form_multy_tag_tr("Filter mask", 0x3F25 + board_number * 0x100, count));
		main_div.append(tbody_do)
		
		count = 1;
		tbody_alarm.append(form_multy_header("Alarm Relay:", count));
		tbody_alarm.append(form_multy_tag_tr("Value", 0x3F21 + 0 * 0x100, count));
		tbody_alarm.append(form_multy_tag_tr("Invert polarity", 0x3F22 + 0 * 0x100, count));
		tbody_alarm.append(form_multy_tag_tr("Error mode", 0x3F23 + 0 * 0x100, count));
		tbody_alarm.append(form_multy_tag_tr("Error value", 0x3F24 + 0 * 0x100, count));
		tbody_alarm.append(form_multy_tag_tr("Filter mask", 0x3F25 + 0 * 0x100, count));
		tab_table.append(tbody_alarm)
		tab_table.append(tbody_do);
		tab_table.append(tbody_di);

		main_div.append(tab_table);
		$(`#board_${board_number}`).children('.accordion-body').append(main_div);




	}
	 else if ((type == board_types.em_h) || (type == board_types.em_l))
	{
	    var table2 = $('<table>').addClass('data');
	    var boyan2 = $('<div>').attr({id: "boyan2"})
	    var settings_head = $('<div>').addClass("accordion-header").text('Settings');
	    table.append(form_tag_tr("Scheme:", 0x4060, 1));
	    table.append(form_tag_tr("Current range:", 0x4060, 2));
	    table.append(form_tag_tr("Current range d:", 0x4060, 3));	
	    table.append(form_tag_divide_tr("CTR:", 0x4060, 4, 0x4060, 5));	
	    table.append(form_tag_divide_tr("CTR d:", 0x4060, 6, 0x4060, 7));	
	    table.append(form_tag_divide_tr("VTR:", 0x4060, 8, 0x4060, 9));	
	    var settings_body = $('<div>').addClass("accordion-body").append(table);
	    
	    boyan2.append(settings_head);
	    boyan2.append(settings_body);

	    var db_settings_head = $('<div>').addClass("accordion-header").text('Deadband Settings');
	    var table_head = $('<tr>').addClass('table_header');
	    table_head.append($('<td colspan="3">').text('Deadband Reference:'))
	    table_head.append($('<td colspan="2">').text('Deadband, %:'))
	    table2.append(table_head)
	    table2.append(form_tag_tr2("Ia, Ib, Ic,\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0 A: ", 0x4072, 1, " ", 0x406E, 1));
	    table2.append(form_tag_tr2("Id, \u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0A: ", 0x4072, 2, " ", 0x406E, 2));
	    table2.append(form_tag_tr2("U, \u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0V: ", 0x4073, 1, " ", 0x406F, 1));
	    table2.append(form_tag_tr2("P, kW/ Q, kvar/ S, kVA: ", 0x4074, 1, " ", 0x4070, 1));
	    //table2.append(form_tag_tr2("Psum, kW: ", 0x4074, 2, " ", 0x4070, 1));
	    table2.append(form_tag_tr2("PF \u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0: ", 0x4074, 3, " ", 0x4070, 2));
	    table2.append(form_tag_tr2("F, \u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0Hz: ", 0x4075, 1, " ", 0x4071, 1));
	    table2.append(form_tag_tr2("THD I, \u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0%: ", 0x4075, 2, " ", 0x4071, 2));
	    table2.append(form_tag_tr2("THD U, \u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0\u00A0%: ", 0x4075, 2, " ", 0x4071, 3));
	    var db_settings_body = $('<div>').addClass("accordion-body").append(table2);
	    boyan2.append(db_settings_head);
	    boyan2.append(db_settings_body);

	    var main_description = {name: "Current, Voltage, Power Factor", blocks: [
			{params: [
			    {name: "Ia,\u00A0\u00A0\u00A0 A: ", index: 0x4064, sub: 1},
			    {name: "Ib,\u00A0\u00A0\u00A0 A: ", index: 0x4064, sub: 2},
			    {name: "Ic,\u00A0\u00A0\u00A0 A: ", index: 0x4064, sub: 3},
			    {name: "Iavg,\u00A0 A: ", index: 0x4064, sub: 5},
			    {name: "Id,\u00A0\u00A0mA: ", index: 0x4064, sub: 4}
			]},
			{params: [
			    {name: "Ua,\u00A0\u00A0 V: ", index: 0x4065, sub: 1},
			    {name: "Ub,\u00A0\u00A0 V: ", index: 0x4065, sub: 2},
			    {name: "Uc,\u00A0\u00A0 V: ", index: 0x4065, sub: 3},
			    {name: "Uavg, V: ", index: 0x4065, sub: 4}
			]},
			{params: [
			    {name: "Uab,\u00A0\u00A0 V: ", index: 0x4065, sub: 5},
			    {name: "Ubc,\u00A0\u00A0 V: ", index: 0x4065, sub: 6},
			    {name: "Uca,\u00A0\u00A0 V: ", index: 0x4065, sub: 7},
			    {name: "ULavg, V: ", index: 0x4065, sub: 8}
			]},
			{params: [
			    {name: "PFa: ", index: 0x4066, sub: 13},
			    {name: "PFb: ", index: 0x4066, sub: 14},
			    {name: "PFc: ", index: 0x4066, sub: 15},
			    {name: "PFavg: ", index: 0x4066, sub: 16}
			]}
		    ]}

	    var power = {name: "Power", blocks: [
			{params: [
			    {name: "Pa, kW: ", index: 0x4066, sub: 1},
			    {name: "Pb, kW: ", index: 0x4066, sub: 2},
			    {name: "Pc, kW: ", index: 0x4066, sub: 3},
			    {name: "P,\u00A0 kW: ", index: 0x4066, sub: 4}
			]},
			{params: [
			    {name: "Qa, kvar: ", index: 0x4066, sub: 5},
			    {name: "Qb, kvar: ", index: 0x4066, sub: 6},
			    {name: "Qc, kvar: ", index: 0x4066, sub: 7},
			    {name: "Q,\u00A0 kvar: ", index: 0x4066, sub: 8}
			]},
			{params: [
			    {name: "Sa, kVA: ", index: 0x4066, sub: 9},
			    {name: "Sb, kVA: ", index: 0x4066, sub: 10},
			    {name: "Sc, kVA: ", index: 0x4066, sub: 11},
			    {name: "S,\u00A0 kVA: ", index: 0x4066, sub: 12}
			]}
		    ]}

	    var energy = {name: "Energy", blocks: [
			{params: [
			    {name: "Wa+: ", index: 0x4067, sub: 2},
			    {name: "Wb+: ", index: 0x4067, sub: 3},
			    {name: "Wc+: ", index: 0x4067, sub: 4},
			    {name: "W+\u00A0: ", index: 0x4067, sub: 5}
			]},
			{params: [
			    {name: "Wa-: ", index: 0x4067, sub: 6},
			    {name: "Wb-: ", index: 0x4067, sub: 7},
			    {name: "Wc-: ", index: 0x4067, sub: 8},
			    {name: "W-\u00A0: ", index: 0x4067, sub: 9}
			]},
			{params: [
			    {name: "WQa+: ", index: 0x4067, sub: 10},
			    {name: "WQb+: ", index: 0x4067, sub: 11},
			    {name: "WQc+: ", index: 0x4067, sub: 12},
			    {name: "WQ+\u00A0: ", index: 0x4067, sub: 13}
			]},
			{params: [
			    {name: "WQa-: ", index: 0x4067, sub: 14},
			    {name: "WQb-: ", index: 0x4067, sub: 15},
			    {name: "WQc-: ", index: 0x4067, sub: 16},
			    {name: "WQ-\u00A0: ", index: 0x4067, sub: 17}
			]},
			{params: [
			    {name: "WSa: ", index: 0x4067, sub: 18},
			    {name: "WSb: ", index: 0x4067, sub: 19},
			    {name: "WSc: ", index: 0x4067, sub: 20},
			    {name: "WS\u00A0: ", index: 0x4067, sub: 21}
			]}
		    ]}


	    var quality = {name: "Quality", blocks: [
			{params: [
			    {name: "F, Hz: ", index: 0x4068, sub: 1}
			]},
			{params: [
			    {name: "THD Ua,\u00A0\u00A0 %: ", index: 0x4068, sub: 2},
			    {name: "THD Ub,\u00A0\u00A0 %: ", index: 0x4068, sub: 3},
			    {name: "THD Uc,\u00A0\u00A0 %: ", index: 0x4068, sub: 4},
			    {name: "THD Uavg, %: ", index: 0x4068, sub: 5}
			]},
			{params: [
			    {name: "THD Ia,\u00A0\u00A0 %: ", index: 0x4068, sub: 6},
			    {name: "THD Ib,\u00A0\u00A0 %: ", index: 0x4068, sub: 7},
			    {name: "THD Ic,\u00A0\u00A0 %: ", index: 0x4068, sub: 8},
			    {name: "THD Iavg, %: ", index: 0x4068, sub: 9}
			]}
		    ]}

	    var head = $('<div>').addClass("accordion-header").text(main_description.name);
	    var body = $('<div>').addClass("accordion-body")
	    boyan2.append(head);
	    create_block(body, main_description)
	    boyan2.append(body);

	    var head = $('<div>').addClass("accordion-header").text(power.name);
	    var body = $('<div>').addClass("accordion-body")
	    boyan2.append(head);
	    create_block(body, power)
	    boyan2.append(body);
	    
	    var head = $('<div>').addClass("accordion-header").text(energy.name);
	    var body = $('<div>').addClass("accordion-body")
	    boyan2.append(head);
	    var table = $('<table>').append(form_tag_tr("pulsQty, kWh/kvarh/kVAh: ", 0x4067, 1))
	    body.append(table)
	    create_block(body, energy)
	    boyan2.append(body);

	    var head = $('<div>').addClass("accordion-header").text(quality.name);
	    var body = $('<div>').addClass("accordion-body")
	    boyan2.append(head);
	    create_block(body, quality)
	    boyan2.append(body);

	    boyan2.accordion({ heightStyle: 'content', header: '.accordion-header', active: 0});
	    boyan2.accordion( "option", "collapsible", true );
	    $(`#board_${board_number}`).children('.accordion-body').append(boyan2);
	}
    }
}				
else
{
    $(`#board_${board_number}`).hide();
}
}
}

function response_ready()
{
var types = get_board_types()
types.shift()
show_boards_by_type(types)
user.parse_page()

$('.can_hide').each(function( index )
{
var form = $(this).children('.value_td').children('.tag').children('.apply_form')

if ($(form).hasClass('empty'))
{
    $(this).hide()
}
});

$("div[index='1001:0']").hide()			
}

function get_board_types()
{
var response_values = [];
var responseLines = get_board_type_xhr.responseText.split('\n');
var responseLine = responseLines[1];
//console.log("responseLine:"+responseLine);
/*if ((responseLines[1].search( />>>ERROR<<</i ) != -1) || (responseLines[1].search( /!!!ERROR!!!/i ) != -1))
    {
        alert('Ошибка в ответе с сервера:' + responseLine);
    }*/

    response_values = responseLine.split('&#&');
    response_values.pop();
    //console.log('response_values: ' + response_values);
    return response_values;
}

$(document).on('click', '.accordion-header', function()
{ 
    selected_accordion = $(this).index();
});

$(document).on('value_loaded', 'div[tb_index="1001_0"]', function( e )
{ 
    var device_error = $(this).text()
    if (device_error > 0)
    {
        $('.device_status').addClass('device_error')
    }
    else
    {
        $('.device_status').removeClass('device_error')
    }

    $(this).removeClass('value_loaded')
});

$(document).on('value_loaded', '.board_status', function( e )
{ 
    var board = $(this).children('form').children('div.value')
    var board_error = board.text()
    var status_index = $(this).attr('index')
    if (board_error > 0)
    {
        $(`div[status_index="${status_index}"]`).addClass('device_error')
    }
    else
    {
        $(`div[status_index="${status_index}"]`).removeClass('device_error')
    }

    //$(this).removeClass('board_error')
    $(this).removeClass('value_loaded')
});

    

get_board_type_xhr.onreadystatechange = function()
{
    //console.log(get_board_type_xhr.readyState);
    if (get_board_type_xhr.readyState == 4)
    {	
        if (get_board_type_xhr.status == 200)
        {
            response_ready();
        } 
        else 
        {			
            alert("Проверьте соединение с контроллером...");
        }
    }
}
